%define ocamlname cpuid

Name:           ocaml-%{ocamlname}
Version:        0.1.1
Release:        1%{?dist}.emp1
Summary:        Detect CPU features
License:        ISC
URL:            https://github.com/pqwy/cpuid
Source0:        %{ocamlname}-%{version}.tbz

Requires:  	ocaml >= 4.01.0
Requires:	ocaml-result

BuildRequires:  ocaml >= 4.01.0
BuildRequires:  opam-installer >= 2.0
BuildRequires:  opam >= 2.0
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-topkg-devel >= 0.9.0
BuildRequires:	ocaml-result-devel
BuildRequires:	ocaml-ocb-stubblr

Conflicts:	ocb-stubblr < 0.1.0

%description
cpuid allows detection of CPU features from OCaml.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-result-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-%{version}

%build
# dirty hack cause pkg.ml calls opam
export OPAMROOT=%{buildroot}/opam-root
opam init -y

ocaml pkg/pkg.ml build --tests false

rm -rf %{buildroot}/opam-root

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
echo %{ocamlname} > \
    %{buildroot}/%{_libdir}/ocaml/stublibs/dll%{ocamlname}_unix_stubs.so.owner

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGES.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
